unit SocketCommandSSPI;

{
Composants TClientCMDSocketSSPI et TServerCMDSocketSSPI (drivs des composants anctres de TClientCMDSocket et TServerCMDSocket),
sockets non bloquants. Ces composants ont t dvelopps en s'inspirant du code http://www.torry.net/authorsmore.php?id=7131
de Naberegnyh Sergey N. et orients objet.

La procdure d'authentification rejoint celle expose par Microsoft sur http://msdn.microsoft.com/en-us/library/aa379449%28v=vs.85%29
(utilisation des packages NTLM et Kerberos selon les cas).

TClientCMDSocketSSPI
-----------------

Proprits :
 - Mode : SSPIAMCurrentUser pour utiliser les droits de l'utilisateur courant
       ou SSPIAMLogon pour utiliser les droits d'un autre utilisateur
 - Domain : pour dfinir le domaine de l'utilisateur (cas o Mode = SSPIAmLogin)
 - UserName : pour dfinir le login de l'utilisateur (cas o Mode = SSPIAmLogin)
 - Password : pour dfinir le mot de passe de l'utilisateur (cas o Mode = SSPIAmLogin)
 - IsAuthenticating : Indique si le processus d'authentification est en cours

Procdure :
 - Authenticate(Timeout: cardinal=0) : pour procder  l'authentification.
   Si le serveur ne renvoit pas de rponse avant TimeOut millisecondes alors l'vnement OnAuthFailed est invoqu

Evnements :
 - OnAuthFailed : chec d'authentification
 - OnAuthSuccess : succs de l'authentification.


TClientCMDSocketSSPI
-----------------

Proprit :
 - IsAuthenticating : Indique si un processus d'authentification est en cours
 - GuestEnabled : Indique si l'authentification anonyme est autorise

Evnements :
 - OnAuthenticating : survient quand un client tente une authentification (possibilit d'accepter ou refuser)
 - OnAuthFailed : chec d'authentification
 - OnAuthSuccess : succs de l'authentification.


Fonction supplmentaire :
 - SSPIErrorMessage(SSPI_Erreur: SSPI_ERROR): string;
   Renvoit le libell de l'erreur

 Test sous Delphi 7 & XE.

 Columbo pour phidels.com

 version 1.2 (03/11/2012) : Correction de la mthode d'obtention du ServerLogonName
 version 1.1 (22/09/2012)
}

interface

uses Windows, SysUtils, WinSock, Classes, Math, ScktComp, SocketCommand, Variants, ExtCtrls;

const
  secur32 = 'secur32.dll';
  netapi32lib = 'netapi32.dll';
  SECURITY_NATIVE_DREP  = $00000010;
  SECPKG_ATTR_SIZES            = 0;
  SECBUFFER_TOKEN              = 2; // Security token
  SECBUFFER_VERSION = 0;
  SECBUFFER_DATA               = 1; // Packet data
  SECBUFFER_PADDING            = 9; // non-data padding
  SECPKG_CRED_INBOUND  = $00000001;
  SECPKG_CRED_OUTBOUND = $00000002;
  ISC_REQ_INTEGRITY              = $00010000;
  SECPKG_ATTR_NEGOTIATION_INFO = 12;
  SEC_WINNT_AUTH_IDENTITY_ANSI    = $1;
  SEC_WINNT_AUTH_IDENTITY_UNICODE = $2;
  SEC_I_COMPLETE_NEEDED = HRESULT($00090313);
  SEC_I_COMPLETE_AND_CONTINUE = HRESULT($00090314);
  SEC_E_OK = HRESULT($00000000);
  CRED_MAX_DOMAIN_TARGET_NAME_LENGTH       = (256+1+80);
  CRED_MAX_USERNAME_LENGTH                 = (256+1+256);
  sPackageName: String = 'Negotiate';
  Addr_Buf_Len = SizeOf(TSockAddrIn) + 16;
  MAX_AUTHDATA_SIZE=$7FFF;
  NERR_BASE = 2100;
  NERR_DCNotFound          = (NERR_BASE+353);

type
  PTokenUser = ^TTokenUser;
  TTokenUser = packed record
    User: SID_AND_ATTRIBUTES;
  end;
  NET_API_STATUS = DWORD;
  SEC_CHAR = CHAR;
  PSEC_CHAR = ^SEC_CHAR;
  PSecChar = ^TSecChar;
  TSecChar = SEC_CHAR;
  SECURITY_STATUS = longint;
  PSecHandle = ^SecHandle;
  _SecHandle = record
    dwLower: Longword;
    dwUpper: Longword;
  end;
  SecHandle = _SecHandle;
  TSecHandle = SecHandle;
  CredHandle = SecHandle;
  PCredHandle = ^CredHandle;
  TCredHandle = CredHandle;

  CtxtHandle = SecHandle;
  PCtxtHandle = ^CtxtHandle;

  PSecPkgContext_Sizes = ^SecPkgContext_Sizes;
  _SecPkgContext_Sizes = record
    cbMaxToken: Cardinal;
    cbMaxSignature: Cardinal;
    cbBlockSize: Cardinal;
    cbSecurityTrailer: Cardinal;
  end;
  SecPkgContext_Sizes = _SecPkgContext_Sizes;
  PTimeStamp = ^LARGE_INTEGER;
  TimeStamp = LARGE_INTEGER;
  TTimeStamp = TimeStamp;

  PSecBuffer = ^SecBuffer;
  _SecBuffer = record
    cbBuffer: Cardinal;   // Size of the buffer, in bytes
    BufferType: Cardinal; // Type of the buffer (below)
    pvBuffer: Pointer;    // Pointer to the buffer
  end;
  SecBuffer = _SecBuffer;
  PSecBufferDesc = ^SecBufferDesc;
  _SecBufferDesc = record
    ulVersion: Cardinal;  // Version number
    cBuffers: Cardinal;   // Number of buffers
    pBuffers: PSecBuffer; // Pointer to array of buffers
  end;
  SecBufferDesc = _SecBufferDesc;

  SEC_WCHAR = WCHAR;
  PSecWChar = ^TSecWChar;
  TSecWChar = SEC_WCHAR;

  PSecPkgInfoW = ^SecPkgInfoW;
  _SecPkgInfoW = record
    fCapabilities: Cardinal; // Capability bitmask
    wVersion: Word; // Version of driver
    wRPCID: Word; // ID for RPC Runtime
    cbMaxToken: Cardinal; // Size of authentication token (max)
    Name: PSecWChar; // Text name
    Comment: PSecWChar; // Comment
  end;
  SecPkgInfoW = _SecPkgInfoW;
  TSecPkgInfoW = SecPkgInfoW;

  PSecPkgInfoA = ^SecPkgInfoA;
  _SecPkgInfoA = record
    fCapabilities: Cardinal; // Capability bitmask
    wVersion: Word; // Version of driver
    wRPCID: Word; // ID for RPC Runtime
    cbMaxToken: Cardinal; // Size of authentication token (max)
    Name: PSecChar; // Text name
    Comment: PSecChar; // Comment
  end;
  SecPkgInfoA = _SecPkgInfoA;

  SEC_GET_KEY_FN = procedure (
    Arg: Pointer;                           // Argument passed in
    Principal: Pointer;                     // Principal ID
    KeyVer: Cardinal;                       // Key Version
    var Key: Pointer;                       // Returned ptr to key
    var Status: SECURITY_STATUS); stdcall;  // returned status

 _SEC_WINNT_AUTH_IDENTITY_W = record
    User: PWideChar;
    UserLength: Cardinal;
    Domain: PWideChar;
    DomainLength: Cardinal;
    Password: PWideChar;
    PasswordLength: Cardinal;
    Flags: Cardinal;
  end;
  SEC_WINNT_AUTH_IDENTITY_W = _SEC_WINNT_AUTH_IDENTITY_W;
  PSEC_WINNT_AUTH_IDENTITY_W = ^SEC_WINNT_AUTH_IDENTITY_W;
  TSecWinNTAuthIdentityW = SEC_WINNT_AUTH_IDENTITY_W;
  PSecWinNTAuthIdentityW = PSEC_WINNT_AUTH_IDENTITY_W;

  _SEC_WINNT_AUTH_IDENTITY_A = record
    User: PChar;
    UserLength: Cardinal;
    Domain: PChar;
    DomainLength: Cardinal;
    Password: PChar;
    PasswordLength: Cardinal;
    Flags: Cardinal;
  end;
  SEC_WINNT_AUTH_IDENTITY_A = _SEC_WINNT_AUTH_IDENTITY_A;
  PSEC_WINNT_AUTH_IDENTITY_A = ^SEC_WINNT_AUTH_IDENTITY_A;
  TSecWinNTAuthIdentityA = SEC_WINNT_AUTH_IDENTITY_A;
  PSecWinNTAuthIdentityA = PSEC_WINNT_AUTH_IDENTITY_A;

  PSecPkgContext_NegotiationInfoW = ^SecPkgContext_NegotiationInfoW;
  _SecPkgContext_NegotiationInfoW = record
    PackageInfo: PSecPkgInfoW;
    NegotiationState: Cardinal;
  end;
  SecPkgContext_NegotiationInfoW = _SecPkgContext_NegotiationInfoW;
  TSecPkgContextNegotiationInfoW = SecPkgContext_NegotiationInfoW;
  PSecPkgContextNegotiationInfoW = PSecPkgContext_NegotiationInfoW ;

  PSecPkgContext_NegotiationInfoA = ^SecPkgContext_NegotiationInfoA;
  _SecPkgContext_NegotiationInfoA = record
    PackageInfo: PSecPkgInfoA;
    NegotiationState: Cardinal;
  end;
  SecPkgContext_NegotiationInfoA = _SecPkgContext_NegotiationInfoA;
  TSecPkgContextNegotiationInfoA = SecPkgContext_NegotiationInfoA;
  PSecPkgContextNegotiationInfoA = PSecPkgContext_NegotiationInfoA;

  {$IFDEF UNICODE}
  PSecPkgInfo = PSecPkgInfoW;
  TSecWinNTAuthIdentity = TSecWinNTAuthIdentityW;
  PSecWinNTAuthIdentity = PSecWinNTAuthIdentityW;
  SecPkgContext_NegotiationInfo  = SecPkgContext_NegotiationInfoW;
  {$ELSE}
  PSecPkgInfo = PSecPkgInfoA;
  TSecWinNTAuthIdentity = TSecWinNTAuthIdentityA;
  PSecWinNTAuthIdentity = PSecWinNTAuthIdentityA;
  SecPkgContext_NegotiationInfo  = SecPkgContext_NegotiationInfoA;
  {$ENDIF}
  
  SSPI_ERROR=(SSPI_NONE, SSPI_ABORT, SSPI_CLIENT_ABORT, SSPI_ACQUIRECREDENTIALSHANDLE_FAILED, SSPI_QUERYSECURITYPACKAGEINFO_FAILED,
            SSPI_QUERYCONTEXTATTRIBUTES_FAILED, SSPI_SIGNATURE_FAILED, SSPI_SENDING_FAILED,
            SSPI_INBOUND_TOO_LONG, SSPI_ACCESS_DENIED, SSPI_CONTEXT_SECURITY_FAILED,
            SSPI_COMPLETEAUTHTOKEN_FAILED, SSPI_CREDENTIAL_ERROR, SSPI_AUTHENTICATION_FAILED, SSPI_IMPERSONATION_FAILED, SSPI_GUEST_DISALLOWED, SSPI_TIMEOUT);

  TSSPIAuthMode=(SSPIAMLogon, SSPIAMCurrentUser);
  TSSPIAuthenticationState=(SSPIASStart, SSPIASAuthenticating, SSPIASEnd);
  TSSPIAuthenticationData = record
    State: TSSPIAuthenticationState;
    PackageName: string;
  end;
  TSSPIState=(SSPIUnknown, SSPIAuthentication, SSPISuccess, SSPIFailed);

  TSSPIAuthenticatingEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; var Continue: bool) of object;
  TSSPIFailedNotifyEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; SSPI_Error: SSPI_ERROR ; LastError: integer) of object;
  TSSPISuccessNotifyEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; UserName, Domain: string ; SID: PSID ; PackageName: string) of object;
  TServerCMDSocketSSPI= class;

  TClientCMDSocketSSPI = class(TClientCMDSocket)
  private
    FSSPISuccessNotifyEvent: TSSPISuccessNotifyEvent;
    FSSPIFailedNotifyEvent: TSSPIFailedNotifyEvent;
    FMode: TSSPIAuthMode;
    FDomain, FUserName, FPassword: string;
    FAuthenticationData: TSSPIAuthenticationData;
    FState: TSSPIState;
    CredHandle: TCredHandle;
    SecHandle: TSecHandle;
    InDesc, OutDesc: SecBufferDesc;
    InSecBuf, OutSecBuf: SecBuffer;
    Timer: TTimer;
    ServerLogonName: string;
    procedure DoAuthentication(const Buf: TArrayOfByte);
    procedure DoFinalizeAuthentication;
  protected
    procedure OnTimeOut(Sender: TObject);
    function CheckSign(const SecHandle: TSecHandle; PData: PByte; DataLen: cardinal; out PResponse: PChar; out ResponseLen: integer): boolean;
    function CreataCredentialHandle(out CredHandle: TCredHandle): boolean;
    procedure DoAuthSuccess(UserName, Domain: string ; SID: PSID ; PackageName: string);
    procedure DoAuthFailed(SSPI_Error: SSPI_ERROR ; LastError: integer=0);
    procedure DoActivate(Value: Boolean); override;
    function GetAuthenticationProgress: bool;
    procedure OnCommandReceive(Sender: TObject ; Socket: TCustomWinSocket; Command: TCommand ; var Continue: bool); override;
    procedure OnCommandOK(Sender: TObject ; Socket: TCustomWinSocket; CommandEx: TCommandUser); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Authenticate(TimeOut: cardinal=0);
    property IsAuthenticating: bool read GetAuthenticationProgress;
  published
    property Mode: TSSPIAuthMode read FMode write FMode;
    property Domain: string read FDomain write FDomain;
    property UserName: string read FUserName write FUserName;
    property Password: string read FPassword write FPassword;
    property Active;
    property Address;
    property CaseSensitive;
    property Commands;
    property Host;
    property Port;
    property Service;
    property OnLookup;
    property OnConnecting;
    property OnAuthFailed: TSSPIFailedNotifyEvent read FSSPIFailedNotifyEvent write FSSPIFailedNotifyEvent;
    property OnAuthSuccess: TSSPISuccessNotifyEvent read FSSPISuccessNotifyEvent write FSSPISuccessNotifyEvent;
    property OnConnect;
    property OnCommand;
    property OnCommandError;
    property OnCommandTimeOut;
    property OnDisconnect;
    property OnWrite;
    property OnError;
  end;

  TServerClientCMDSocketSSPI = class(TServerClientCMDSocket)
  private
    FOwner: TServerCMDSocketSSPI;
    SecHandle: TSecHandle;
    CredHandle: TCredHandle;
    FAuthenticationData: TSSPIAuthenticationData;
    FState: TSSPIState;
    FSecSizes: SecPkgContext_Sizes;
    FSignatureSize: DWORD;
    FUserName, FDomain: string;
    FSID: PSID;
    FSignature: array[0..255] of Byte;
    cMaxMsgSize: cardinal;
    FTag: integer;
    FIsAuthenticating: bool;
    function SignBuffer(PData: PByte; DataLen: integer): boolean;
    procedure SendResponse(PBuf: Pointer; BufLen: cardinal);
    procedure DoFinalizeAuthentication;
  protected
    procedure Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent); override;
    procedure OnCommandOK(Sender: TObject ; Socket: TCustomWinSocket; CommandEx: TCommandUser); override;
    procedure OnCommandReceive(Sender: TObject ; Socket: TCustomWinSocket; Command: TCommand ; var Continue: bool); override;
    procedure DoAuthentication(const Buf: TArrayOfByte);
    procedure DoAuthSuccess;
    procedure DoAuthFailed(SSPI_Error: SSPI_ERROR);
  public
    constructor Create(AOwner: TServerCMDSocketSSPI; Socket: TSocket; ServerWinSocket: TServerWinSocket);
    property IsAuthenticating: bool read FIsAuthenticating write FIsAuthenticating;
  end;

  TServerCMDSocketSSPI = class(TServerCMDSocket)
  private
    FSSPIAuthenticatingEvent: TSSPIAuthenticatingEvent;
    FSSPISuccessNotifyEvent: TSSPISuccessNotifyEvent;
    FSSPIFailedNotifyEvent: TSSPIFailedNotifyEvent;
    FGuestEnabled: bool;
  protected
    procedure GetSocket(Sender: TObject; ASocket: TSocket; var ClientSocket: TServerClientWinSocket); override;
  public
    property Socket: TServerWinCMDSocket read GetServerSocket;
    property ServerType: TServerType read GetServerType;
  published
    property Active;
    property GuestEnabled: bool read FGuestEnabled write FGuestEnabled default false;
    property Port;
    property Service;
    property ThreadCacheSize default 10;
    property OnListen;
    property OnAccept;
    property OnAuthenticating: TSSPIAuthenticatingEvent read FSSPIAuthenticatingEvent write FSSPIAuthenticatingEvent;
    property OnAuthFailed: TSSPIFailedNotifyEvent read FSSPIFailedNotifyEvent write FSSPIFailedNotifyEvent;
    property OnAuthSuccess: TSSPISuccessNotifyEvent read FSSPISuccessNotifyEvent write FSSPISuccessNotifyEvent;
    property OnGetSocket;
    property OnClientConnect;
    property OnClientDisconnect;
    property OnClientWrite;
    property OnClientError;
    property OnClientCommand;
    property OnClientCommandError;
    property OnClientCommandTimeOut;
  end;

function SSPIErrorMessage(SSPI_Erreur: SSPI_ERROR): string;
function AcceptSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pInput: PSecBufferDesc; fContextReq, TargetDataRep: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcceptSecurityContext';
function CompleteAuthToken(phContext: PCtxtHandle; pToken: PSecBufferDesc): SECURITY_STATUS; stdcall;  external secur32 name 'CompleteAuthToken';
function ImpersonateSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'ImpersonateSecurityContext';
function RevertSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'RevertSecurityContext';
function MakeSignature(phContext: PCtxtHandle; fQOP: Cardinal; pMessage: PSecBufferDesc; MessageSeqNo: Cardinal): SECURITY_STATUS; stdcall; external secur32 name 'MakeSignature';
function FreeContextBuffer(pvContextBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'FreeContextBuffer';
function DeleteSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'DeleteSecurityContext';
function FreeCredentialHandle(phCredential: PCredHandle): SECURITY_STATUS; stdcall; external secur32 name 'FreeCredentialsHandle';
function VerifySignature(phContext: PCtxtHandle; pMessage: PSecBufferDesc; MessageSeqNo: Cardinal; var pfQOP: Cardinal): SECURITY_STATUS; stdcall; external secur32 name 'VerifySignature';
function NetGetDCName(servername: LPCWSTR; domainname: LPCWSTR; bufptr: Pointer): NET_API_STATUS; stdcall; external netapi32lib;
function NetGetAnyDCName(servername: LPCWSTR; domainname: LPCWSTR; bufptr: Pointer): NET_API_STATUS; stdcall; external netapi32lib;
function NetApiBufferFree(Buffer: Pointer): NET_API_STATUS; stdcall; external netapi32lib;
{$IFDEF UNICODE}
function QueryContextAttributes(phContext: PCtxtHandle; ulAttribute: Cardinal; pBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'QueryContextAttributesW';
function QuerySecurityPackageInfo(pszPackageName: PSecWChar; var ppPackageInfo: PSecPkgInfoW): SECURITY_STATUS; stdcall; external secur32 name 'QuerySecurityPackageInfoW';
function AcquireCredentialsHandle(pszPrincipal, pszPackage: PSecWChar; fCredentialUse: Cardinal; pvLogonId, pAuthData: Pointer; pGetKeyFn: SEC_GET_KEY_FN; pvGetKeyArgument: Pointer; phCredential: PCredHandle; var ptsExpiry: TTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcquireCredentialsHandleW';
function InitializeSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pszTargetName: PSecWChar; fContextReq, Reserved1, TargetDataRep: Cardinal; pInput: PSecBufferDesc; Reserved2: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'InitializeSecurityContextW';
{$ELSE}
function QueryContextAttributes(phContext: PCtxtHandle; ulAttribute: Cardinal; pBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'QueryContextAttributesA';
function QuerySecurityPackageInfo(pszPackageName: PSecChar; var ppPackageInfo: PSecPkgInfoA): SECURITY_STATUS; stdcall; external secur32 name 'QuerySecurityPackageInfoA';
function AcquireCredentialsHandle(pszPrincipal, pszPackage: PSecChar; fCredentialUse: Cardinal; pvLogonId, pAuthData: Pointer; pGetKeyFn: SEC_GET_KEY_FN; pvGetKeyArgument: Pointer; phCredential: PCredHandle; var ptsExpiry: TTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcquireCredentialsHandleA';
function InitializeSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pszTargetName: PSecChar; fContextReq, Reserved1, TargetDataRep: Cardinal; pInput: PSecBufferDesc; Reserved2: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'InitializeSecurityContextA';
{$ENDIF}
function GetUserNameEx(NameFormat: DWORD; lpNameBuffer: LPWSTR; var nSize: DWORD): Boolean; stdcall; external secur32 Name 'GetUserNameExW';

procedure Register;

implementation

procedure Register;
begin RegisterComponents('TCP/IP', [TClientCMDSocketSSPI, TServerCMDSocketSSPI]); end;

const AUTH_COMMAND: AnsiString='AUTHSSPI';
      NameDisplay            = 3;
      NameSamCompatible = 2;
      NameDnsDomain          = 12;
      S_SSPI_ERROR: array[SSPI_ABORT..SSPI_ERROR(High(SSPI_ERROR))] of string=(
            'Canceled by server', 'Canceled by client', 'AcquireCredentialsHandle failed', 'QuerySecurityPackageInfo failed',
            'QueryContextAttributes failed', 'Signature failed', 'Sending failed',
            'Inbound message too long', 'Access denied', 'InitializeSecurityContext failed',
            'CompleteAuthToken failed', 'Credential creation error', 'Authentication failed',
            'Impersonation failed', 'Guest connection disallowed', 'Timeout');

function SSPIErrorMessage(SSPI_Erreur: SSPI_ERROR): string;
begin
     if SSPI_ERREUR in [Low(SSPI_ERROR)..High(SSPI_ERROR)] then result:=S_SSPI_ERROR[SSPI_Erreur]
                                                           else result:='';
end;

function GetUserNameExString(NameFormat: cardinal): string; overload;
var Size : DWORD;
    Buffer : array[0..1024] of WideChar;
begin
     Size := sizeof(Buffer);
     if GetUserNameEx(NameFormat, Buffer, Size) then SetString(result, Buffer, Size) else result:='';
end;

function GetUserNameExString: string; overload;
begin
     Result := GetUserNameExString(NameDnsDomain);
     if Result='' then Result:=GetUserNameExString(NameDisplay);
end;

function GetPDCName:String;
var Bufptr       : Pointer;
    Res          : NET_API_STATUS;
begin
     try
        try
           Res:=NetGetDCName(nil, nil, @bufptr);
           if ((Res=NERR_DCNotFound) or (Res=ERROR_INVALID_NAME)) then
           begin
                Res:=NetGetAnyDCName(nil, nil, @bufptr);
                if Res<>ERROR_SUCCESS then Exit;
           end;
           Result:=WideCharToString(Bufptr);
        finally
           NetApiBufferFree(BufPtr);
        end;
     except end;
end;

function GetDomainAndPDCName(var DomainName, PDCName: string): Boolean;
var Token: THandle;
    InfoSize, UserNameSize, DomainNameSize: Cardinal;
    User: PTokenUser;
    Use: SID_NAME_USE;
    _DomainName, _UserName: array[0..255] of Char;
begin
     Result := False;
     try
        DomainName := '.';
        PDCName:=GetPDCName;
        Token := 0;
        if OpenThreadToken(GetCurrentThread, TOKEN_QUERY, True, Token) or
          ((GetLastError = ERROR_NO_TOKEN) and OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, Token)) then
        try
           GetTokenInformation(Token, TokenUser, nil, 0, InfoSize);
           User := AllocMem(InfoSize * 2);
           try
              if GetTokenInformation(Token, TokenUser, User, InfoSize * 2, InfoSize) then
              begin
                   DomainNameSize := SizeOf(_DomainName);
                   UserNameSize := SizeOf(_UserName);
                   Result := LookupAccountSid(nil, User^.User.Sid, _UserName, UserNameSize, _DomainName, DomainNameSize, Use);
                   if Result then SetString(DomainName, _DomainName, StrLen(_DomainName));
              end;
           finally
              FreeMem(User);
           end;
        finally
           CloseHandle(Token);
        end;
     except
     end;
end;

/////////////////////////////////////////////////////////////////////////////////
///////////////////////////////  TClientCMDSocketSSPI ///////////////////////////
/////////////////////////////////////////////////////////////////////////////////

constructor TClientCMDSocketSSPI.Create(AOwner: TComponent);
begin
     FMode:=SSPIAMLogon;
     FState:=SSPIUnknown;
     Timer:=TTimer.Create(nil); Timer.Enabled:=false; Timer.OnTimer:=OnTimeOut;
     inherited Create(AOwner);
end;

destructor TClientCMDSocketSSPI.Destroy;
begin
     Timer.Free;
     inherited;
end;

procedure TClientCMDSocketSSPI.OnTimeOut(Sender: TObject);
begin
     Timer.Enabled:=false;
     if (FClientSocket.Connected) and (FState=SSPIAuthentication) then DoAuthFailed(SSPI_TIMEOUT, -1);
end;

procedure TClientCMDSocketSSPI.DoActivate(Value: Boolean);
begin
     FState:=SSPIUnknown;
     inherited;
end;

function TClientCMDSocketSSPI.GetAuthenticationProgress: bool;
begin Result:=FState=SSPIAuthentication; end;

procedure TClientCMDSocketSSPI.DoAuthFailed(SSPI_Error: SSPI_ERROR ; LastError: integer=0);
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPIFailed;
          if LastError=0 then LastError:=GetLastError;
          if Assigned(FSSPIFailedNotifyEvent) then FSSPIFailedNotifyEvent(Self, FClientSocket, SSPI_Error, LastError);
          DoFinalizeAuthentication;
     end;
end;

procedure TClientCMDSocketSSPI.DoAuthSuccess(UserName, Domain: string ; SID: PSID ; PackageName: string);
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPISuccess;
          if Assigned(FSSPISuccessNotifyEvent) then FSSPISuccessNotifyEvent(Self, FClientSocket, UserName, Domain, SID, PackageName);
          DoFinalizeAuthentication;
     end;
end;

// Vrification du message reu
function TClientCMDSocketSSPI.CheckSign(const SecHandle: TSecHandle; PData: PByte; DataLen: cardinal; out PResponse: PChar; out ResponseLen: integer): boolean;
var Desc: SecBufferDesc;
    SecBuf: array[0..1] of SecBuffer;
    QOP: Cardinal;
    SS: SECURITY_STATUS;
begin
     with Desc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 2; pBuffers:= @SecBuf; end;
     with SecBuf[0] do begin cbBuffer:= PDWORD(PData)^; BufferType:= SECBUFFER_TOKEN; pvBuffer:= Pointer(Cardinal(PData) + SizeOf(DWORD)); end;
     PResponse:= Pointer(Cardinal(PData) + SecBuf[0].cbBuffer + SizeOf(DWORD));
     ResponseLen:= DataLen - SecBuf[0].cbBuffer - SizeOf(DWORD);
     with SecBuf[1] do begin cbBuffer:= ResponseLen; BufferType:= SECBUFFER_DATA; pvBuffer:= PResponse; end;
     QOP:= 0; SS:= VerifySignature(@SecHandle, @desc, 0, QOP); Result:= Succeeded(SS);
end;

// Cration d'un Handle d'authentification  transmettre au serveur
function TClientCMDSocketSSPI.CreataCredentialHandle(out CredHandle: TCredHandle): boolean;
var ss: SECURITY_STATUS;
    Expiry: TimeStamp;
    AuthIdent: TSecWinNTAuthIdentity;
    PAuthident: PSecWinNTAuthIdentity;
    wDomain: array[0..CRED_MAX_DOMAIN_TARGET_NAME_LENGTH] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    wUserName: array[0..CRED_MAX_USERNAME_LENGTH] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    wPassword: array[0..127] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    i: integer;
begin
     if FMode=SSPIAMLogon then
     begin
          FillChar(wDomain, SizeOf(wDomain), #0);
          FillChar(wUserName, SizeOf(wUserName), #0);
          FillChar(wPassword, SizeOf(wPassword), #0);
          for i:=0 to Min(SizeOf(wDomain), length(Domain))-1 do wDomain[i]:=Domain[i+1];
          for i:=0 to Min(SizeOf(wUserName), length(UserName))-1 do wUserName[i]:=UserName[i+1];
          for i:=0 to Min(SizeOf(wPassword), length(Password))-1 do wPassword[i]:=Password[i+1];
          with AuthIdent do
          begin
               User:= @wUserName;
               UserLength:= StrLen(AuthIdent.User);
               Password:= @wPassword;
               PasswordLength:= StrLen(AuthIdent.Password);
               Domain:= @wDomain;
               DomainLength:= StrLen(AuthIdent.Domain);
               Flags:={$IFDEF UNICODE}SEC_WINNT_AUTH_IDENTITY_UNICODE{$ELSE}SEC_WINNT_AUTH_IDENTITY_ANSI{$ENDIF};
          end;
          PAuthIdent:= @AuthIdent;
      end else PAuthident:= nil;
      SetLastError(0);
      SS:= AcquireCredentialsHandle(nil, @sPackageName[1], SECPKG_CRED_OUTBOUND, nil, PAuthIdent, nil, nil, @CredHandle, Expiry);
      FillChar(wPassword, SizeOf(wPassword), 0);
      Result:= Succeeded(SS);
end;

// Lancement de l'authentification
procedure TClientCMDSocketSSPI.Authenticate(TimeOut: cardinal=0);
var Domain, PDCName: string;
begin
     if (FClientSocket.Connected) and (FState<>SSPIAuthentication) then
     begin
          FState:=SSPIAuthentication;
          FillChar(SecHandle, SizeOf(SecHandle), 0);
          if TimeOut<>0 then begin Timer.Enabled:=false; Timer.Interval:=TimeOut; Timer.Enabled:=true; end;
          if CreataCredentialHandle(CredHandle) then
          begin
               FState:=SSPIAuthentication;
               if FMode=SSPIAMCurrentUser then
               begin
                    GetDomainAndPDCName(Domain, PDCName);
                    if PDCName<>'' then ServerLogonName:=Domain+'\'+PDCName else ServerLogonName:=Domain;
               end else ServerLogonName:='';
               FAuthenticationData.State:=SSPIASStart;
               FAuthenticationData.PackageName:='';
               DoAuthentication(nil);
          end else DoAuthFailed(SSPI_CREDENTIAL_ERROR);
     end;
end;

// Fin de l'authentification
procedure TClientCMDSocketSSPI.DoFinalizeAuthentication;
begin
     Timer.Enabled:=false;
     FState:=SSPIUnknown;
     if (SecHandle.dwLower or SecHandle.dwUpper) <> 0 then DeleteSecurityContext(@SecHandle);
     if (CredHandle.dwLower or CredHandle.dwUpper) <> 0 then FreeCredentialHandle(@CredHandle);
end;

// Arrive d'une commande d'authentification
procedure TClientCMDSocketSSPI.OnCommandReceive(Sender: TObject ; Socket: TCustomWinSocket; Command: TCommand ; var Continue: bool);
begin if Command.Command=AUTH_COMMAND then Continue:=true else inherited; end;

// Rception de la commande d'authentification
procedure TClientCMDSocketSSPI.OnCommandOK(Sender: TObject ; Socket: TCustomWinSocket; CommandEx: TCommandUser);
var Buf: TArrayOfByte;
begin
     if CommandEx.Command=AUTH_COMMAND then
     begin
          // Rception d'une commande d'authentification transmise par le serveur
          if (FState=SSPIAuthentication) and (length(CommandEx.Argument)=3) and (CommandEx.Argument[0].Typ=AT_BOOL) and (CommandEx.Argument[1].Typ=AT_INT64) then
          begin
               // Poursuite de l'authentification
               if bool(CommandEx.Argument[0].Data) and
                  (CommandEx.Argument[1].Data>=Low(TSSPIAuthenticationState)) and
                  (CommandEx.Argument[1].Data<=High(TSSPIAuthenticationState)) and
                  VarIsArray(CommandEx.Argument[2].Data) and
                  (VarArrayDimCount(CommandEx.Argument[2].Data)=1) and
                  (VarArrayLowBound(CommandEx.Argument[2].Data, 1)=0) and
                  (VarArrayHighBound(CommandEx.Argument[2].Data, 1)<=MAX_AUTHDATA_SIZE) then
               begin
                    Setlength(Buf, 0);
                    VariantToArrayOfByte(CommandEx.Argument[2].Data, Buf);
                    DoAuthentication(Buf);
                    Finalize(Buf);
               end
               else
               // Erreur lors de l'authentification
               if not bool(CommandEx.Argument[0].Data) and
                  (CommandEx.Argument[1].Data>Low(SSPI_ERROR)) and
                  (CommandEx.Argument[1].Data<=High(SSPI_ERROR)) and
                  (CommandEx.Argument[2].Typ=AT_INT64) then
               begin
                    SetLastError(CommandEx.Argument[2].Data);
                    DoAuthFailed(CommandEx.Argument[1].Data, CommandEx.Argument[2].Data);
               end;
          end;
     end
     else
     inherited;
end;

// Procdure d'authentification (appele plusieurs fois lors des changes avec le serveur)
procedure TClientCMDSocketSSPI.DoAuthentication(const Buf: TArrayOfByte);
var PInDesc: PSecBufferDesc;
    Attrib: ULONG;
    SS: SECURITY_STATUS;
    NegInfo: SecPkgContext_NegotiationInfo;
    PSH: PCtxtHandle;
    Expiry: TimeStamp;
    Reponse: PChar;
    Reponselength, SIDSize: integer;
    WBuf: TArrayOfByte;
    OutBuf: array[0..MAX_AUTHDATA_SIZE] of Byte;
    User, Domain: string;
    SID: PSID;
    Data: Variant;
    ErrorCode: SSPI_Error;
    {$IFDEF UNICODE}
    Server: PSecWChar;
    {$ELSE}
    Server: PSecChar;
    {$ENDIF}
begin
     ErrorCode:=SSPI_NONE;
     case FAuthenticationData.State of
     // Fin du processus d'authentification
     SSPIASEnd:
     try
        if CheckSign(SecHandle, @Buf[0], length(Buf), Reponse, ReponseLength) then
        begin
             User:=String(Reponse);
             Reponse:=Reponse+length(User)+1;
             Domain:=String(Reponse);
             Reponse:=Reponse+length(Domain)+1;
             SIDSize:=ReponseLength-(length(User)+1)*SizeOf(User[1])-(length(Domain)+1)*SizeOf(Domain[1]);
             SID:=GetMemory(SIDSize);
             CopyMemory(SID, Reponse, SIDSize);
             DoAuthSuccess(User, Domain, SID, FAuthenticationData.PackageName);
             FreeMem(SID);
        end
        else ErrorCode:=SSPI_SIGNATURE_FAILED;
     except
     end
     // Dbut ou continuation du processus d'authentificaiton
     else
     try
        with OutDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @OutSecBuf; end;
        with OutSecBuf do begin cbBuffer:= SizeOf(OutBuf); BufferType:= SECBUFFER_TOKEN; pvBuffer:= @OutBuf; end;
        if FAuthenticationData.State=SSPIASStart then begin PSH:= nil; PInDesc:= nil; end else
        begin
             with InDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @InSecBuf; end;
             with InSecBuf do begin cbBuffer:= length(Buf); BufferType:= SECBUFFER_TOKEN; pvBuffer:= Buf; end;
             PSH:= @SecHandle;
             PInDesc:= @InDesc;
        end;

        if ServerLogonName<>'' then Server:=@ServerLogonName[1] else Server:=nil;
        SS:= InitializeSecurityContext(@CredHandle, PSH, Server, ISC_REQ_INTEGRITY, 0, SECURITY_NATIVE_DREP, PInDesc, 0, @SecHandle, @OutDesc, Attrib, @Expiry);
        if Failed(SS) then ErrorCode:=SSPI_CONTEXT_SECURITY_FAILED
        else
        begin
             if (SEC_I_COMPLETE_NEEDED = SS) or (SEC_I_COMPLETE_AND_CONTINUE = SS) then
             begin
                  SS:= CompleteAuthToken(@SecHandle, @OutDesc);
                  if Failed(SS) then ErrorCode:=SSPI_COMPLETEAUTHTOKEN_FAILED;
             end;
             if (ErrorCode=SSPI_NONE) and (OutSecBuf.cbBuffer <> 0) then
             begin
                  Setlength(WBuf, OutSecBuf.cbBuffer);
                  try
                     CopyMemory(@WBuf[0], OutSecBuf.pvBuffer, OutSecBuf.cbBuffer);
                     Data:=ArrayOfByteToVariant(WBuf);
                     if SendCommand(AUTH_COMMAND, [true, FAuthenticationData.State, Data])='' then ErrorCode:=SSPI_SENDING_FAILED;
                  finally
                     VarClear(Data);
                     Finalize(WBuf);
                  end;
             end;
             if ErrorCode=SSPI_NONE then
               if SEC_E_OK = SS then
               begin
                   SS:= QueryContextAttributes(@SecHandle, SECPKG_ATTR_NEGOTIATION_INFO, @NegInfo);
                   if Succeeded(SS) then
                   begin
                        FAuthenticationData.State:=SSPIASEnd;
                        FAuthenticationData.PackageName:=string(NegInfo.PackageInfo.Name);
                   end else ErrorCode:=SSPI_QUERYCONTEXTATTRIBUTES_FAILED;
                   FreeContextBuffer(NegInfo.PackageInfo);
               end
               else FAuthenticationData.State:=SSPIASAuthenticating;
        end;
     except
     end;
     end;
     if ErrorCode<>SSPI_NONE then DoAuthFailed(ErrorCode);
end;

/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////  TServerCMDSocketSSPI //////////////////////////
/////////////////////////////////////////////////////////////////////////////////

procedure TServerCMDSocketSSPI.GetSocket(Sender: TObject; ASocket: TSocket; var ClientSocket: TServerClientWinSocket);
begin ClientSocket:=TServerClientCMDSocketSSPI.Create(self, ASocket, FServerSocket); end;

/////////////////////////////////////////////////////////////////////////////////
////////////////////////////  TServerClientWinSocketSSPI ////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Envoi de la rponse signe
procedure TServerClientCMDSocketSSPI.SendResponse(PBuf: Pointer; BufLen: cardinal);
var WBuf: TArrayOfByte;
    Data: Variant;
begin
     if SignBuffer(PBuf, BufLen) then
     begin
          Setlength(WBuf, SizeOf(Cardinal)+FSignatureSize+Buflen);
          try
             CopyMemory(@WBuf[0], @FSignatureSize, SizeOf(Cardinal));
             CopyMemory(@WBuf[SizeOf(Cardinal)], @FSignature[0], FSignatureSize);
             CopyMemory(@WBuf[SizeOf(Cardinal)+FSignatureSize], PBuf, BufLen);
             SetLastError(0);
             Data:=ArrayOfByteToVariant(WBuf);
             if SendCommand(AUTH_COMMAND, [true, FAuthenticationData.State, Data])='' then DoAuthFailed(SSPI_SENDING_FAILED);
          finally
             VarClear(Data);
             Finalize(WBuf);
          end;
     end else DoAuthFailed(SSPI_SIGNATURE_FAILED);
end;

// Signature du buffer avant l'envoi
function TServerClientCMDSocketSSPI.SignBuffer(PData: PByte; DataLen: integer): boolean;
var Desc: SecBufferDesc;
    SecBuf: array[0..2] of SecBuffer;
    SS: SECURITY_STATUS;
begin
     SetLastError(0);
     with Desc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 3; pBuffers:= @SecBuf; end;
     with SecBuf[0] do begin cbBuffer:= FSecSizes.cbMaxSignature; BufferType:= SECBUFFER_TOKEN; pvBuffer:= @FSignature; end;
     with SecBuf[1] do begin cbBuffer:= DataLen; BufferType:= SECBUFFER_DATA; pvBuffer:= PData; end;
     with SecBuf[2] do begin cbBuffer:= 0; BufferType:= SECBUFFER_PADDING; pvBuffer:= nil; end;
     SS:= MakeSignature(@SecHandle, 0, @Desc, 0);
     Result:= Succeeded(SS); if Result then FSignatureSize:= SecBuf[0].cbBuffer;
end;

// Socket Serveur->Client
constructor TServerClientCMDSocketSSPI.Create(AOwner: TServerCMDSocketSSPI; Socket: TSocket; ServerWinSocket: TServerWinSocket);
begin
     CredHandle.dwLower:=0;
     CredHandle.dwUpper:=0;
     FIsAuthenticating:=false;
     FOwner:=AOwner;
     inherited Create(AOwner, Socket, ServerWinSocket);
end;

procedure TServerClientCMDSocketSSPI.Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent);
begin
     case SocketEvent of
     seDisconnect: begin if FIsAuthenticating then DoFinalizeAuthentication; inherited; end;
     seConnect: begin FState:=SSPIUnknown; FIsAuthenticating:=false; FTag:=0; inherited; end;
     else inherited;
     end;
end;

procedure TServerClientCMDSocketSSPI.DoAuthSuccess;
var WBuf: array of byte;
    SS: SECURITY_STATUS;
    NegInfo: SecPkgContext_NegotiationInfo;
    FcbSid: cardinal;
begin
     if FState=SSPIAuthentication then
     begin
          if FSID<>nil then FcbSid:=GetLengthSid(FSID) else FcbSid:=0;
          Setlength(WBuf, (length(FUserName)+1)*SizeOf(FUserName[1])+(length(FDomain)+1)*SizeOf(FDomain[1])+byte(FcbSid));
          ZeroMemory(WBuf, length(WBuf));
          CopyMemory(@WBuf[0], PChar(FUserName), length(FUserName)*SizeOf(FUserName[1]));
          CopyMemory(@WBuf[(length(FUserName)+1)*SizeOf(FUserName[1])], PChar(FDomain), length(FDomain)*SizeOf(FDomain[1]));
          CopyMemory(@WBuf[(length(FUserName)+1)*SizeOf(FUserName[1])+(length(FDomain)+1)*SizeOf(FDomain[1])], FSID, FcbSid);
          SendResponse(WBuf, length(WBuf));
          Finalize(WBuf);
          if FState<>SSPIFailed then
          begin
               SS:= QueryContextAttributes(@SecHandle, SECPKG_ATTR_NEGOTIATION_INFO, @NegInfo);
               if Succeeded(SS) then FAuthenticationData.PackageName:=string(NegInfo.PackageInfo.Name);
               FreeContextBuffer(NegInfo.PackageInfo);
               FState:=SSPISuccess;
               if Assigned(FOwner.FSSPISuccessNotifyEvent) then FOwner.FSSPISuccessNotifyEvent(Self, Self, string(FUserName), string(FDomain), FSID, FAuthenticationData.PackageName);
               DoFinalizeAuthentication;
          end;
     end;
end;

procedure TServerClientCMDSocketSSPI.DoAuthFailed(SSPI_Error: SSPI_ERROR);
var ErrorCode: integer;
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPIFailed;
          if SSPI_Error=SSPI_ABORT then SetLastError(0);
          ErrorCode:=GetLastError;
          if ErrorCode=0 then ErrorCode:=-1;
          if SSPI_Error<>SSPI_CLIENT_ABORT then SendCommand(AUTH_COMMAND, [false, integer(SSPI_Error), integer(ErrorCode)]);
          if (SSPI_Error<>SSPI_ABORT) and Assigned(FOwner.FSSPIFailedNotifyEvent) then FOwner.FSSPIFailedNotifyEvent(Self, Self, SSPI_Error, ErrorCode);
          DoFinalizeAuthentication;
     end;
end;

procedure TServerClientCMDSocketSSPI.DoFinalizeAuthentication;
begin
     if Assigned(FSID) then begin FreeMem(FSID); FSID:=nil; end;
     FIsAuthenticating:=false;
     FTag:=0;
     if (SecHandle.dwLower or SecHandle.dwUpper) <> 0 then DeleteSecurityContext(@SecHandle);
     if (CredHandle.dwLower or CredHandle.dwUpper) <> 0 then FreeCredentialHandle(@CredHandle);
end;

// Arrive d'une commande d'authentification
procedure TServerClientCMDSocketSSPI.OnCommandReceive(Sender: TObject ; Socket: TCustomWinSocket; Command: TCommand ; var Continue: bool);
begin if Command.Command=AUTH_COMMAND then Continue:=true else inherited; end;

// Rception de la commande d'authentification
procedure TServerClientCMDSocketSSPI.OnCommandOK(Sender: TObject ; Socket: TCustomWinSocket; CommandEx: TCommandUser);
var Buf: TArrayOfByte;
    pPkgInfo: PSecPkgInfo;
    Expiry: TimeStamp;
    SS: SECURITY_STATUS;
    Continue: bool;
    ErrorCode: SSPI_ERROR;
begin
     if CommandEx.Command=AUTH_COMMAND then
     begin
          // Rception d'une commande d'authentification
          if (length(CommandEx.Argument)=3) and
             (CommandEx.Argument[0].Typ=AT_BOOL) and CommandEx.Argument[0].Data and
             (CommandEx.Argument[1].Typ=AT_INT64) and
             (CommandEx.Argument[1].Data>=Low(TSSPIAuthenticationState)) and
             (CommandEx.Argument[1].Data<=High(TSSPIAuthenticationState)) and
             VarIsArray(CommandEx.Argument[2].Data) and
             (VarArrayDimCount(CommandEx.Argument[2].Data)=1) and
             (VarArrayLowBound(CommandEx.Argument[2].Data, 1)=0) and
             (VarArrayHighBound(CommandEx.Argument[2].Data, 1)<=MAX_AUTHDATA_SIZE) then
          begin
               Setlength(Buf, 0);
               VariantToArrayOfByte(CommandEx.Argument[2].Data, Buf);
               if FIsAuthenticating and (TSSPIAuthenticationState(CommandEx.Argument[1].Data)<>SSPIASStart) then DoAuthentication(Buf)
               else
               if TSSPIAuthenticationState(CommandEx.Argument[1].Data)=SSPIASStart then
               begin
                    if FIsAuthenticating then DoAuthFailed(SSPI_CLIENT_ABORT);
                    Continue:=true;
                    FSID:=nil;
                    if Assigned(FOwner.FSSPIAuthenticatingEvent) then FOwner.FSSPIAuthenticatingEvent(Self, Self, Continue);
                    if Continue then
                    begin
                         SetLastError(0);
                         SS:= QuerySecurityPackageInfo(@sPackageName[1], pPkgInfo);
                         if Succeeded(SS) then
                         begin
                              cMaxMsgSize:= pPkgInfo.cbMaxToken;
                              SS:=AcquireCredentialsHandle(nil, @sPackageName[1], SECPKG_CRED_INBOUND, nil, nil, nil, nil, @CredHandle, Expiry);
                              if Failed(SS) then ErrorCode:=SSPI_ACQUIRECREDENTIALSHANDLE_FAILED else ErrorCode:=SSPI_NONE;
                         end
                         else ErrorCode:=SSPI_QUERYSECURITYPACKAGEINFO_FAILED;
                         FreeContextBuffer(pPkgInfo);
                    end
                    else ErrorCode:=SSPI_ABORT;
                    FAuthenticationData.State:=SSPIASStart;
                    FState:=SSPIAuthentication;
                    FIsAuthenticating:=true;
                    if ErrorCode<>SSPI_NONE then DoAuthFailed(ErrorCode) else DoAuthentication(Buf);
               end;
               Finalize(Buf);
          end;
     end
     else
     inherited;
end;

// Appel d'un client pour d'authentification
procedure TServerClientCMDSocketSSPI.DoAuthentication(const Buf: TArrayOfByte);
var WBuf: TArrayOfByte;
    SS: SECURITY_STATUS;
    Expiry: TimeStamp;
    snu: SID_NAME_USE;
    OutDesc, InDesc: SecBufferDesc;
    OutBuf, InBuf: SecBuffer;
    OutB: PChar;
    Attribs: ULONG;
    NameLen, DomainSize: Cardinal;
    Data: Variant;
    ErrorCode: SSPI_ERROR;
    SamCompatible: string;
    FcbSid: cardinal;
    bSuccess: bool;
begin
     ErrorCode:=SSPI_NONE;
     with OutDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @OutBuf; end;
     with OutBuf do begin cbBuffer:= cMaxMsgSize; OutB:=GetMemory(cMaxMsgSize); BufferType:= SECBUFFER_TOKEN; pvBuffer:=OutB; end;
     with InDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @InBuf; end;
     with InBuf do begin cbBuffer:= length(Buf); BufferType:= SECBUFFER_TOKEN; pvBuffer:= Buf; end;

     try
        Attribs:= 0;
        if FAuthenticationData.State=SSPIASStart then
        begin
             SS:= AcceptSecurityContext(@CredHandle, nil, @InDesc, Attribs, SECURITY_NATIVE_DREP, @SecHandle, @OutDesc, Attribs, @Expiry);
             FAuthenticationData.State:=SSPIASAuthenticating;
        end
        else SS:= AcceptSecurityContext(@CredHandle, @SecHandle, @InDesc, Attribs, SECURITY_NATIVE_DREP, @SecHandle, @OutDesc, Attribs, @Expiry);
        if Failed(SS) then ErrorCode:=SSPI_AUTHENTICATION_FAILED;

        if ErrorCode=SSPI_NONE then
        begin
             if (SS = SEC_I_COMPLETE_NEEDED) or (SS = SEC_I_COMPLETE_AND_CONTINUE) then
             begin
                  SS:= CompleteAuthToken(@SecHandle, @OutDesc);
                  if Failed(SS) then ErrorCode:=SSPI_AUTHENTICATION_FAILED;
             end;
             if (ErrorCode=SSPI_NONE) and (SS = SEC_E_OK) then
             begin
                  SS:= QueryContextAttributes(@SecHandle, SECPKG_ATTR_SIZES, @FSecSizes);
                  if Failed(SS) then ErrorCode:=SSPI_QUERYCONTEXTATTRIBUTES_FAILED
                  else
                  if Succeeded(ImpersonateSecurityContext(@SecHandle)) then
                  try
                     NameLen:= SizeOf(FSignature);
                     if GetUserName(@FSignature[0], NameLen) then SetString(FUserName, PChar(@FSignature[0]), NameLen - 1);
                     DomainSize:=0;
                     FcbSid:=0;
                     SamCompatible:=GetUserNameExString(NameSamCompatible);
                     LookupAccountName(nil, PChar(SamCompatible), nil, FcbSid, nil, DomainSize, snu);
                     FSID:=GetMemory(FcbSid);
                     FDomain:=StringOfChar(#0, DomainSize);
                     bSuccess:=LookupAccountName(nil, PChar(SamCompatible), FSID, FcbSid, @FDomain[1], DomainSize, snu);
                     if (not bSuccess or (bSuccess and (snu<>SidTypeUser))) and not FOwner.GuestEnabled then ErrorCode:=SSPI_GUEST_DISALLOWED
                     else
                     begin
                          FDomain:=Trim(FDomain);
                          FAuthenticationData.State:=SSPIASEnd;
                     end;
                  finally
                     RevertSecurityContext(@SecHandle);
                  end
                  else ErrorCode:=SSPI_IMPERSONATION_FAILED;
             end;

             if (ErrorCode=SSPI_NONE) and (OutBuf.cbBuffer <> 0) then
             begin
                  Setlength(WBuf, OutBuf.cbBuffer);
                  try
                     CopyMemory(@WBuf[0], OutBuf.pvBuffer, OutBuf.cbBuffer);
                     SetLastError(0);
                     Data:=ArrayOfByteToVariant(WBuf);
                     if SendCommand(AUTH_COMMAND, [true, FAuthenticationData.State, Data])='' then ErrorCode:=SSPI_SENDING_FAILED;
                  finally
                     VarClear(Data);
                     Finalize(WBuf);
                  end;
             end;
        end;
     finally
       FreeMemory(OutB);
     end;
     if ErrorCode<>SSPI_NONE then DoAuthFailed(ErrorCode) else if FAuthenticationData.State=SSPIASend then DoAuthSuccess;
end;

end.
